package agentspace.discovery;

import java.net.URI;
import java.util.EventObject;

public class RuntimeRegistryEvent extends EventObject {
	URI uri;
	int heartbeatPort;
	AgentServerInfo asi;
	
	public RuntimeRegistryEvent(URI uri, AgentServerInfo asi) {
		super(asi);
		this.uri = uri;
		this.asi = asi;	
	}
	
	public RuntimeRegistryEvent(URI uri, int heartbeatPort, AgentServerInfo asi) {
		this(uri, asi);
		this.heartbeatPort = heartbeatPort;
	}

	public URI getUri() {
		return uri;
	}
	
	public int getPort() {
		return heartbeatPort;
	}

	public AgentServerInfo getAgentServerInfo() {
		return asi;
	}
}

