package agentspace.discovery.gomi;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.NoSuchElementException;

public class ExpiredEntryMonitor implements Runnable {
	boolean active = false;
	List<HeartbeatEntry> list;
	List<ExpiredListener> listeners;
	long lastTime = 0;
	
	public ExpiredEntryMonitor(List<HeartbeatEntry> list, List<ExpiredListener> listeners) {
		this.list = list;
		this.listeners = listeners;
		active = true;
	}
	
	@Override
	public void run() {
		long currentTime = System.currentTimeMillis();
		Iterator<HeartbeatEntry> itr = list.iterator();
		while (itr.hasNext() && active) {
			HeartbeatEntry entry = itr.next();
//			System.out.println("CheckingExpiredItem: expired item = "+entry.getName()+
//					", period:"+entry.getDuration()+", difference:"+(currentTime - entry.getLastTime()));
			if (currentTime - entry.getLastTime() > entry.getDuration()) {
				System.out.println("CheckingExpiredItem: expired? = "+((entry.getLastTime() - currentTime)));
				System.out.println("CheckingExpiredItem: timeout at entry = "+entry);
				Iterator<ExpiredListener> j = listeners.iterator();
				while (j.hasNext()) {
					ExpiredListener listener = j.next();
					entry.setExpiredTime(currentTime);
					listener.expired(new ExpiredEvent(entry));
				}
			}
		}
		lastTime = currentTime;
	}
	
	public void stop() {
		active = false;
	}
}
