package agentspace.discovery.gomi;

import java.util.LinkedList;
import java.util.List;

import agentspace.discovery.AgentServerInfo;

public class HeartbeatEntry {
	AgentServerInfo info;
	protected long lastTime = -1;
	protected long expireTime = -1;
	protected long duration;
	String name;
	
	public HeartbeatEntry(AgentServerInfo info, String name, long duration) {
		this.info = info;
		this.name = name;
		this.duration = duration;
	}

	public long getDuration() {
		return duration;
	}
	
	public void setDuration(long period) {
		this.duration = period;
	}
	
	public long getExpireTime() {
		return expireTime;
	}

	public void setExpiredTime(long expireTime) {
		this.expireTime = expireTime;
	}

	public void setLastTime(long lastTime) {
		this.lastTime = lastTime;
	}

	public long getLastTime() {
		return lastTime;
	}

	public boolean isExpired(long time) {
		if (time - lastTime > duration) {
			return true;
		}
		else {
			return false;
		}
	}
	
	public String getName() {
		return name;
	}

	public AgentServerInfo getServerInfo() {
		return info;
	}
	
	public String toString() {
		String s = "";
		if (info != null) {
			s = s + info.getHostName() + ":" + info.getDefaultPort() + ":";
		}
		if (name != null) {
			s = s + "name:" + name + ":";
		}
		if (lastTime > 0) {
			s = s + "last_time:" + lastTime + ":";
		}
		if (duration > 0) {
			s = s + "duration:" + duration + ":";
		}
		return s;
	}
}
