/*
 * Copyright (C) 2013 Ichiro Satoh (ichiro@nii.ac.jp)
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting
 * documentation.
 *
 * FREE USE OF THIS SOFTWARE IS ALLOWED IN ITS "AS IS" CONDITION.
 * BUT WITHOUT WARRANTY. THE AUTHORS DISCLAIM ANY LIABILITY OF ANY 
 * KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS 
 * SOFTWARE.
 */

package agentspace.dmi;

import java.io.Serializable;

public class Type implements Serializable {
	private static final long serialVersionUID = 4041947995901871639L;

	/* Not use "enum" because type information may be shared between different computers */
	static final public byte TYPE_OBJECT = 0;
	static final public byte TYPE_BOOLEAN = 1;
	static final public byte TYPE_BYTE = 2;
	static final public byte TYPE_SHORT = 3;
	static final public byte TYPE_CHAR = 4;
	static final public byte TYPE_INT = 5;
	static final public byte TYPE_LONG = 6;
	static final public byte TYPE_FLOAT = 7;
	static final public byte TYPE_DOUBLE = 8;
	static final public byte TYPE_VOID = 9;

	static public String toString(byte type) {
		switch(type) {
		case TYPE_OBJECT:
			return "TYPE_OBJECT";
		case TYPE_BOOLEAN:
			return "TYPE_BOOLEAN";
		case TYPE_BYTE:
			return "TYPE_BYTE";
		case TYPE_SHORT:
			return "TYPE_SHORT";
		case TYPE_CHAR:
			return "TYPE_CHAR";
		case TYPE_INT:
			return "TYPE_INT";
		case TYPE_LONG:
			return "TYPE_LONG";
		case TYPE_FLOAT:
			return "TYPE_FLOAT";
		case TYPE_DOUBLE:
			return "TYPE_DOUBLE";
		case TYPE_VOID:
			return "TYPE_VOID";
		default:
			return "TYPE_UNKNOWN";
		}
	}
}