package agentspace.monitor.debug;

import java.awt.BorderLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;

import agentspace.AgentServer;
import agentspace.context.ContextManager;
import agentspace.monitor.splash.AgentSplashWindow;
import agentspace.monitor.table.AgentTableControl;
import agentspace.monitor.table.AgentTableToolBar;
import agentspace.monitor.table.AgentTableView;
import agentspace.runtime.event.AgentRuntimeEvent;
import agentspace.runtime.event.AgentRuntimeListener;



public class AgentDebugView extends JFrame {
	AgentTableView list;
	
	public AgentDebugView(ContextManager manager) {
		super("AgentSpace: System Debug ("+AgentServer.getLocalHost()+":"+AgentServer.getDefaultPort()+")");
		
		JPanel buttonPanel =  new JPanel();
		getContentPane().add(buttonPanel, BorderLayout.SOUTH);
		
		AgentSplashWindow w = new AgentSplashWindow(new ImageIcon(
				"agentspace/monitor/images/logo.gif"), 5000);
	    
		
		
		

		AgentTableControl listControl = new AgentTableControl(manager, this);
		AgentTableToolBar listToolBar = new AgentTableToolBar(listControl);
		list = new AgentTableView(listControl, listToolBar);

		JPanel listTab = new JPanel();
		listTab.setLayout(new BorderLayout());
		listTab.add(listToolBar, BorderLayout.NORTH);
		listTab.add(list, BorderLayout.CENTER);

		getContentPane().add(listToolBar, BorderLayout.NORTH);
		getContentPane().add(list, BorderLayout.CENTER);

		setSize(600, 200);
		setVisible(true);
	}
}