/*
 * Copyright (c) 2005, 2010 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

package agentspace.network.protocol;

import java.util.HashMap;
import java.util.Hashtable;

public class ResponseFactory extends Response {
    public void setProtocol(String responseProtocol) {
        this.responseProtocol = responseProtocol;
    }
      
    public void setVersion(String responseVersion) {
        this.responseVersion = responseVersion;
    }
    
    public void setCode(int responseCode) {
        this.responseCode = responseCode;
    }
    
    public void setComment(String responseComment) {
        this.responseComment = responseComment;
    }
    
    public void setContent(byte[] responseContent) {
        if (attributes == null) {
            attributes = new HashMap<String, String>();
        }
        this.responseContent = responseContent;
      }

    public void setAttributes(String name, String property) {
        if (attributes == null) {
            attributes = new Hashtable<String, String>();
        }
        attributes.put(name.toUpperCase(), property);
    }
    
    public String toString() {
    	return super.toString();
    }
}