/*
 * Copyright (c) 2005, 2010 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

package agentspace.network.protocol;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

class Util {
    static public String readLine(InputStream in) throws IOException {
        ByteArrayOutputStream buf = new ByteArrayOutputStream();
        String line = null;
        try {
            byte[] data = null;
            byte previous = 0x0;
            while(true) {
                byte current = (byte)in.read();
                buf.write(current);
                if (previous == '\r' && current == '\n') {
                    data = buf.toByteArray();
                    int len = data.length;
                    if (len > 2) {
                        line = buf.toString().substring(0, len - 2);
                    }
                    break;
                }
                previous = current;
            }
        }
        catch(IOException e) {
            line = buf.toString();
        }
        return line;
    }
}
