/*
 * Copyright (c) 2005 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

/**
 * @author Ichiro Satoh
 * Created on 2005/05/7
 */

package agentspace.network.protocol.rmitp;

public class RmitpConstants {

	/** 2XX: generally "OK" */
	final static public int RMITP_OK = 200;
	final static public int RMITP_CREATED = 201;
	final static public int RMITP_ACCEPTED = 202;
	final static public int RMITP_NOT_AUTHORITATIVE = 203;
	final static public int RMITP_NO_CONTENT = 204;
	final static public int RMITP_RESET = 205;
	final static public int RMITP_PARTIAL = 206;
	
	/** 3XX: relocation/redirect */
	final static public int RMITP_MULT_CHOICE = 300;
	final static public int RMITP_MOVED_PERM = 301;
	final static public int RMITP_MOVED_TEMP = 302;
	final static public int RMITP_SEE_OTHER = 303;
	final static public int RMITP_NOT_MODIFIED = 304;
	final static public int RMITP_USE_PROXY = 305;
	
	/** 4XX: client error */
	final static public int RMITP_BAD_REQUEST = 400;
	final static public int RMITP_UNAUTHORIZED = 401;
	final static public int RMITP_PAYMENT_REQUIRED = 402;
	final static public int RMITP_FORBIDDEN = 403;
	final static public int RMITP_NOT_FOUND = 404;
	final static public int RMITP_BAD_METHOD = 405;
	final static public int RMITP_NOT_ACCEPTABLE = 406;
	final static public int RMITP_PROXY_AUTH = 407;
	final static public int RMITP_CLIENT_TIMEOUT = 408;
	final static public int RMITP_CONFLICT = 409;
	final static public int RMITP_GONE = 410;
	final static public int RMITP_LENGTH_REQUIRED = 411;
	final static public int RMITP_PRECON_FAILED = 412;
	final static public int RMITP_ENTITY_TOO_LARGE = 413;
	final static public int RMITP_REQ_TOO_LONG = 414;
	final static public int RMITP_ILLEGAL_AGENT_STATE = 415;
	final static public int RMITP_UNSUPPORTED_TYPE = 416;
	
	/** 5XX: server error */
	final static public int RMITP_SERVER_ERROR = 500;
	final static public int RMITP_INTERNAL_ERROR = 501;
	final static public int RMITP_BAD_GATEWAY = 502;
	final static public int RMITP_UNAVAILABLE = 503;
	final static public int RMITP_GATEWAY_TIMEOUT = 504;
	final static public int RMITP_VERSION = 505;
	final static public int RMITP_CLASS_NOT_FOUND = 506;
}
