package agentspace.shell;

import java.util.Properties;
import java.util.StringTokenizer;

public abstract class CommandHandler implements Runnable {
	protected String line;
	protected boolean sync;
	protected String result = null;
	protected Exception except = null;
	protected Properties environ;

	public CommandHandler(String line, Properties environ) {
		this(line);
		this.environ = environ;
	}

	public CommandHandler(String line) {
		this.line = line;
	}

	public synchronized void run() {
		try {
//			System.out.println("CommentHandler: "+line);
			result = (String)eval(line);
		}
		catch (Exception e) {
			except = (Exception)e;
		}
		notifyAll();
	}

	public String eval(String line) throws Exception {
		if (line != null && !(line.trim().equals(""))) {
			System.out.println("> "+line);
			String command = getCommand(line);
			String[] args = getArgs(line);
			try {
				result = eval_command(command, args);
				System.out.println(result);
				return result;
			}
			catch (Exception e) {
				e.printStackTrace();
				//	System.out.println(e.getMessage());
				throw e;
			}
		}
		return null;
	}

	public synchronized String getResult() throws Exception {
		while (result == null && except == null) {
			try {
				wait();
			}
			catch(InterruptedException e) {}
		}
		if (result != null) {
			return result;
		}
		else {
			throw except;
		}
	}

	public synchronized Object getException() {
		while (result == null && except == null) {
			try {
				wait();
			}
			catch(InterruptedException e) {}
		}
		return except;
	}

	protected String getCommand(String line) {
		StringTokenizer tokens = new StringTokenizer(line);
		String command = tokens.nextToken();
		return command;
	}

	protected String[] getArgs(String line) {
		String[] tokenlist = null;
		StringTokenizer tokenizer = new StringTokenizer(line);
		if (tokenizer.countTokens() > 0) {
			tokenizer.nextToken();
			tokenlist = new String[tokenizer.countTokens()];
			for ( int i = 0 ; tokenizer.hasMoreTokens() ; i++ ) {
				tokenlist[i] = tokenizer.nextToken();
			}
		}
		return tokenlist;
	}

	abstract protected String eval_command(String command, String[] args);
}

