/*
 * Created on 2005/05/30
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package agent.chat;

import java.io.Serializable;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.util.Enumeration;
import java.util.Vector;

public class ChatReceiver implements Runnable, Serializable {
	String hostname = null;
	int port = -1;
	transient Thread aThread;
	transient DatagramSocket sock = null;

	public ChatReceiver(int port) {
		this.port = port;
	}

	public void run() {
		receiver();
	}

	public void stop() {
		if (sock != null) {
			sock.close();
		}
	}
	
	protected void receiver() {
		try{
			sock = new DatagramSocket(port); 
			while(true) {
				byte[] buf= new byte[2];
				DatagramPacket packet = new DatagramPacket(buf, 2);
				sock.receive(packet);
//				System.out.println("ChatReceiver: "+new String(packet.getData()));
				chatTyped(new String(packet.getData()));
			}
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
		try {
			if (sock != null) {
				sock.close();
			}
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
	protected Vector chatListeners = null; 
		
	protected void chatTyped(String s) {
		if (chatListeners != null) {
			Enumeration e = (Enumeration)chatListeners.elements();
			while(e.hasMoreElements()) {
				ChatListener listener = (ChatListener)e.nextElement();
				listener.chatTyped(new ChatEvent(s));
			}
		}
	}
	
	public synchronized void addChatListener(ChatListener listener) {
		if (chatListeners == null) {
			chatListeners = new Vector();
		}
		chatListeners.addElement(listener);	
	}
	
	public synchronized void removeChatListener(ChatListener listener) {
		if (chatListeners != null) {
			chatListeners.removeElement(listener);
		}
		if (chatListeners.size() == 0) {
			chatListeners.clear();
			chatListeners = null;
		}
	}
}
