
package agent.test;

import agentspace.Agent;
import agentspace.Context;
import agentspace.Duplicatable;
import agentspace.Mobile;
import agentspace.Preservable;
import agentspace.event.AgentEvent;

public class ContextTest implements Agent, Mobile, Duplicatable, Preservable {
	ContextTestWindow window = null;

	public ContextTest() {
		System.out.println("ContextTest: an instance created.");
	}

	public void create(AgentEvent evt, Context context) {
		System.out.println("ContextTest: method create() called");
		if (window == null) {
			window = new ContextTestWindow();
		}
		window.setContext(context);
		window.setVisible(true);
	}

	public void destroy(AgentEvent evt, Context context) {
		System.out.println("ContextTest: method destroy() called");
		window.setVisible(false);
	}

	public void suspend(AgentEvent evt, Context context) {
		System.out.println("ContextTest: method suspend() called");
		window.setVisible(false);
	}

	public void resume(AgentEvent evt, Context context) {
		System.out.println("ContextTest: method resume() called");
		window.setContext(context);
		window.setVisible(true);
	}
	
	public void arrive(AgentEvent evt, Context context) {
		System.out.println("ContextTest: method arrive() called");
		window.setContext(context);
		window.setVisible(true);
	}

	public void leave(AgentEvent evt, Context context) {
		System.out.println("ContextTest: method leave() called");
		window.setVisible(false);
	}

	public void duplicate(AgentEvent evt, Context context) {
		System.out.println("ContextTest: method duplicate() called");
		window.setVisible(false);
	}

	public void parent(AgentEvent evt, Context context) {
		System.out.println("ContextTest: method parent() called");
		window.setContext(context);
		window.setVisible(true);
	}

	public void child(AgentEvent evt, Context context) {
		System.out.println("ContextTest: method child() called");
		window.setContext(context);
		window.setVisible(true);
	}
	
	
	public void setText(String text) {
		window.setText(text);
	}

	public String getText() {
		return window.getText();
	}
}



