/*
 * Created on 2005/05/31
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package agent.test;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.FileDialog;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;

import agentspace.AgentIdentifier;
import agentspace.AgentServer;
import agentspace.Context;
import agentspace.IllegalAgentStateException;
import agentspace.InvalidURLException;

/**
 * @author ichiro
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ContextTestWindow extends Frame implements Serializable {
	TextArea editorArea = null;
	TextField addressField = null;
	Context context = null;

	class EditorActionListener implements ActionListener, Serializable {
		public EditorActionListener() {}

		public void actionPerformed(ActionEvent evt) {
			String command = evt.getActionCommand();
			editorArea.append("> "+command+"\n");
			if (evt.getID() == WindowEvent.WINDOW_CLOSING) {
				dispose();
			}
			else if (command.equals("Move")) {
				if (context != null) {
					try {
						URL url = new URL(addressField.getText());
						System.out.println("EditorWindow: move("+url+")");
						context.move(url);
					}
					catch (MalformedURLException ex) {
						ex.printStackTrace();
					}
					catch (IOException ex) {
						ex.printStackTrace();
					} 
					catch (InvalidURLException ex) {
						ex.printStackTrace();
					}
				}
			}
			
			else if (command.equals("getIdentifier")) {
				editorArea.append(""+context.getIdentifier()+"\n");
			}
			else if (command.equals("getAgents")) {
				AgentIdentifier[] ids = context.getAgents(); 
				for (int i = 0 ; i < ids.length ; i++ ) { 
					editorArea.append("["+i+"] "+ids[i]+"\n");
				}
			}
			else if (command.equals("getName")) {
				editorArea.append(""+context.getName()+"\n");
			}
			else if (command.equals("Copy")) {
				if (context != null) {
					try {
						context.duplicate();
					} 
					catch (IllegalAgentStateException ex) {
						ex.printStackTrace();
					}
				}
			}
			else if (command.equals("Discard")) {
				if (context != null) {
					context.terminate();
				}
			}
			else if (command.equals("Save")) {
				try {
					String fileName = getFileName(false);
					context.store(fileName);
				}
				catch (Exception ex) {
					ex.printStackTrace();
				}
			}
			editorArea.append("----------------------\n");
		}
	}
	
	public static void main(String[] args) {
		ContextTestWindow window = new ContextTestWindow();
		window.setVisible(true);
	}
	
	public void setContext(Context context) {
		this.context = context;
	}
	
	public ContextTestWindow() {
		super("ContextTestWindow");
		EditorActionListener listener = new EditorActionListener(); 
		
		Panel topPanel = new Panel();
		Button getIdentifierButton = new Button("getIdentifier"); 
		getIdentifierButton.addActionListener(listener);
		topPanel.add(getIdentifierButton);
		
		Button getAgentsButton = new Button("getAgents"); 
		getAgentsButton.addActionListener(listener);
		topPanel.add(getAgentsButton);
		
		Button getNameButton = new Button("getName"); 
		getNameButton.addActionListener(listener);
		topPanel.add(getNameButton);
		
		Panel addressPanel = new Panel();
		addressField = new TextField(AgentServer.getTargetURL().toString(), 20);
		Button moveButton = new Button("Move");
		moveButton.addActionListener(listener);
		addressPanel.add(addressField);
		addressPanel.add(moveButton);
				
//		Font f = new Font("Dialog", Font.BOLD, 24);
		editorArea = new TextArea(40, 8);
//		editorArea.setFont(f);
		editorArea.setVisible(true);
		add(topPanel, BorderLayout.NORTH);
		add(editorArea, BorderLayout.CENTER);
		add(addressPanel, BorderLayout.SOUTH);
		setSize(500, 400);
	}
	
	public void setText(String text) {
		editorArea.setText(text);
	}

	public String getText() {
		return editorArea.getText();
	}

	private String getFileName(boolean isOpen) {
		FileDialog dialog = new FileDialog(this,
					isOpen ? "Open File" : "Save File",
							isOpen ? FileDialog.LOAD : FileDialog.SAVE);
		dialog.setVisible(true);
		if (dialog.getDirectory() != null && dialog.getFile() != null) {
			return dialog.getDirectory() + dialog.getFile();
	    }
		else {
			return null;
	    }
	}
}

