package agent.wordcount;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;

public class WordCount {
	final static Integer ONE = new Integer(1);
	final static String DELIMITERS = " \t\n\r\f.,<>\"\'=/{}()";

	public WordCount(String filename) {
		wordCountFromFile(filename);
		Set keys = map.keySet();
		Iterator i = keys.iterator();
		while (i.hasNext()) {
			String key = (String)i.next();
			Integer counter = (Integer)map.get(key);
//			System.out.println("key = "+key+", freqency = "+counter);
		}
	}

	// Define a Map and create a HashMap
	Map map = new HashMap();

	// Return the map
	public Map getMap() {
		return map;
	}

	// Clear the map
	public void clear() {
		map.clear();
	}

	public void wordCountFromFile(String filename) {
		FileInputStream in = null;
		BufferedReader reader = null;
		try {
			in = new FileInputStream(filename);
			reader = new BufferedReader(new InputStreamReader(in));
		}
		catch (IOException e) {
			System.err.println(e);
		}
		String line = null;
		try {
			while((line = reader.readLine()) != null) {
				addWords(line);
			}
		}
		catch (IOException e) {
			System.err.println(e);
		} 
		finally {
			if (in != null) {
				try {
					in.close();
				} 
				catch (IOException ex) {
					ex.printStackTrace();
				}
			}
		}
	}

	private void addWords(String line) {
		// Get map
		Map map = getMap();
		// Split words
		StringTokenizer tokenizer = new StringTokenizer(line, DELIMITERS);
		// For each word
		while (tokenizer.hasMoreTokens()) {
			// Get word
			String key = tokenizer.nextToken();

			// Get frequency
			// If not fount, add word to map with count one
			// Otherwise, add to map with old count + 1

			Integer frequency = (Integer)map.get(key);
			if (frequency == null) {
				frequency = ONE;
			} 
			else {
				int value = frequency.intValue();
				frequency = new Integer(value + 1);
			}
			map.put(key, frequency);
//			System.out.println("key = "+key+", freqency = "+frequency);
		}
	}


	public static void main(String[] args) {
		WordCount wc = new WordCount(args[0]);
	}
}

