package agentspace.discovery.gomi;

public abstract class PacketExpireEntry {
	protected long lastTime = -1;
	protected long expireTime = -1;

	public long getExpireTime() {
		return expireTime;
	}

	public void setExpired(long expireTime) {
		this.expireTime = expireTime;
	}

	public void setLastTime(long lastTime) {
		this.lastTime = lastTime;
	}

	public long getLastTime() {
		return lastTime;
	}

	public void resetLastTime() {
		lastTime = System.currentTimeMillis();
	}

	public boolean isExpired(long time) {
		if (time - lastTime > expireTime) {
			return true;
		}
		else {
			return false;
		}
	}
	
	public abstract void expired(ExpiredEvent evt);
}
