/*
 * Copyright (c) 2020 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

/**
 * @author Ichiro Satoh
 * Created on 2020/12/4
 */

package agentspace.discovery;

import java.net.InetAddress;
import java.net.URI;
import java.net.UnknownHostException;

import agentspace.registry.AgentRegistry;

public class AgentServerInfo {
	protected InetAddress addr = null;
	protected String host = null;
	protected int port = -1;

	public AgentServerInfo(InetAddress addr, int port) {
		this.addr = addr;
		this.port = port;
		host = this.addr.getHostName();
	}
	
	public InetAddress getInetAddress() {
		return addr;
	}

	public String getHostName() {
		return host;
	}

	public int getDefaultPort() {
		return port;
	}
	
	public int hashCode() {
		String s = host + ":" + port;
		return s.hashCode();		
	}
}