package agentspace.discovery;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import agentspace.discovery.network.MulticastPacketManager;
import agentspace.discovery.network.PacketListener;
import agentspace.multicast.Packet;
import agentspace.multicast.SizeLimitExceededPacketException;
import agentspace.registry.AlreadyBoundException;
import agentspace.registry.NotBoundException;

public class Test implements PacketListener {

	MulticastPacketManager manager;
	
	public Test(int port) {
		try {
			manager = new MulticastPacketManager(port);
			manager.start();
			manager.addPacketListener(this, "AGENTSPACE", "LOOKUP");
			manager.addPacketListener(this, "AGENTSPACE", "ADVERTISE");
			manager.addPacketListener(new PacketListener() {
				public void received(Packet packet) {
					System.out.println("Test: listener:"+packet);
				}},  "AGENTSPACE", "ADVERTISE");
			
			for (int i = 0 ; i < 3 ; i++) {
				Packet p1 = new Packet();
				p1.setProtocol("AGENTSPACE");
				p1.setVersion("0.3");
				p1.setUri(new URI("///identifier"));
				p1.setMethod("LOOKUP");
				manager.multicast(p1);
				Packet p2 = new Packet();
				p2.setProtocol("AGENTSPACE");
				p2.setVersion("0.3");
				p2.setUri(new URI("///identifier"));
				p2.setMethod("ADVERTISE");
				manager.multicast(p2);
			}
			manager.removePacketListener(this, "AGENTSPACE", "ADVERTISE");
			manager.removePacketListener(this, "AGENTSPACE", "LOOKUP");
		} 
		catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SizeLimitExceededPacketException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (IOException e) {
			e.printStackTrace();
		} 
		catch (URISyntaxException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (AlreadyBoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NotBoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void received(Packet packet) {
		System.out.println("Test: received("+packet+")");
		
	}

	public static void main(String[] args) {
		int port;
		try {
			if (args.length > 0) {
				port = new Integer(args[0]).intValue();
			}
			else {
				port = 7010;
			}
			Test t = new Test(port);
		} 
		catch (NumberFormatException ex) {
			System.exit(1);
		}
	}
}
