/*
 * Copyright (c) 2005, 2010 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

package agentspace.network.protocol;

import java.util.HashMap;

public class RequestFactory extends Request {
    public RequestFactory() {}
    public void setMethod(String requestMethod) {
    	this.requestMethod = requestMethod;
    }
    
    public void setVersion(String requestVersion) {
    	this.requestVersion = requestVersion;
    }
    
    public void setContent(byte[] requestContent) {
    	this.requestContent = requestContent;
    }
    
    public void setURI(String requestURI) {
    	this.requestURI = requestURI;
    }
    
    public void setProtocol(String requestProtocol) {
    	this.requestProtocol = requestProtocol;
    }
    
    public void setAttributes(String name, String property) {
    	if (attributes == null) {
    		attributes = new HashMap<String, String>();
    	}
    	attributes.put(name.toUpperCase(), property);
    }
    
    public Request makeRequest() throws InvalidRequestException {
    	if (requestMethod == null || requestMethod.length() == 0) {  
    		throw new InvalidRequestException("Invalid method");
    	}
    	if (requestURI == null || requestURI.length() == 0) {  
    		throw new InvalidRequestException("Invalid URI");
    	}
    	if (requestProtocol == null || requestProtocol.length() == 0) {  
    		throw new InvalidRequestException("Invalid Protocol");
    	}
    	return this;
    }
}
