/*
 * Copyright (c) 2005 Ichiro Satoh
 * All Rights Reserved.
 * written by Ichiro Satoh
 *
 * This program was developed by Ichiro Satoh at National Institute 
 * of Informatics as a part of a mobile object system, titled 
 * "AgentSpace".  All the programs of the system is developed by 
 * Ichiro Satoh and all rights are reserved by Ichiro Satoh. 
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 */

/**
 * @author Ichiro Satoh
 * Created on 2005/05/7
 */

package agentspace.network.protocol.matp;

public class MatpConstants {

	/** 2XX: generally "OK" */
	final static public int MATP_OK = 200;
	final static public int MATP_CREATED = 201;
	final static public int MATP_ACCEPTED = 202;
	final static public int MATP_NOT_AUTHORITATIVE = 203;
	final static public int MATP_NO_CONTENT = 204;
	final static public int MATP_RESET = 205;
	final static public int MATP_PARTIAL = 206;
	
	/** 3XX: relocation/redirect */
	final static public int MATP_MULT_CHOICE = 300;
	final static public int MATP_MOVED_PERM = 301;
	final static public int MATP_MOVED_TEMP = 302;
	final static public int MATP_SEE_OTHER = 303;
	final static public int MATP_NOT_MODIFIED = 304;
	final static public int MATP_USE_PROXY = 305;
	
	/** 4XX: client error */
	final static public int MATP_BAD_REQUEST = 400;
	final static public int MATP_UNAUTHORIZED = 401;
	final static public int MATP_PAYMENT_REQUIRED = 402;
	final static public int MATP_FORBIDDEN = 403;
	final static public int MATP_NOT_FOUND = 404;
	final static public int MATP_BAD_METHOD = 405;
	final static public int MATP_NOT_ACCEPTABLE = 406;
	final static public int MATP_PROXY_AUTH = 407;
	final static public int MATP_CLIENT_TIMEOUT = 408;
	final static public int MATP_CONFLICT = 409;
	final static public int MATP_GONE = 410;
	final static public int MATP_LENGTH_REQUIRED = 411;
	final static public int MATP_PRECON_FAILED = 412;
	final static public int MATP_ENTITY_TOO_LARGE = 413;
	final static public int MATP_REQ_TOO_LONG = 414;
	final static public int MATP_ILLEGAL_AGENT_STATE = 415;
	final static public int MATP_UNSUPPORTED_TYPE = 416;
	
	/** 5XX: server error */
	final static public int MATP_SERVER_ERROR = 500;
	final static public int MATP_INTERNAL_ERROR = 501;
	final static public int MATP_BAD_GATEWAY = 502;
	final static public int MATP_UNAVAILABLE = 503;
	final static public int MATP_GATEWAY_TIMEOUT = 504;
	final static public int MATP_VERSION = 505;
	final static public int MATP_CLASS_NOT_FOUND = 506;
}
