package agentspace.packet.multicast;

import java.io.IOException;
import java.io.InterruptedIOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.MulticastSocket;
import java.net.NetworkInterface;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import agentspace.packet.Packet;

public class MulticastUDPReceiver {
	protected MulticastSocket msocket = null; 
	protected DatagramSocket socket = null;
	protected InetAddress group = null;
	protected String groupName;
	protected int port;

    public MulticastUDPReceiver(String groupName, int port) throws IOException {
		this.groupName = groupName;
		this.port = port;
		InetAddress mcastaddr = InetAddress.getByName(groupName);
		InetSocketAddress group = new InetSocketAddress(mcastaddr, port);
		NetworkInterface netIf = NetworkInterface.getByName("bge0");
		msocket = new MulticastSocket(port);
		msocket.setReuseAddress(true);
		msocket.joinGroup(group, netIf);
//        System.out.println("MulticastUDPReceiver: group = "+group);
    }

    public byte[] receive() throws IOException {
        byte[] buf = new byte[Packet.PACKET_SIZE_LIMIT];
        DatagramPacket datagram = new DatagramPacket(buf, buf.length);
        msocket.receive(datagram);
		return datagram.getData();
    }

    public byte[] receive(int timeout) throws IOException, InterruptedIOException {
    	msocket.setSoTimeout(timeout);
        byte[] buf = new byte[Packet.PACKET_SIZE_LIMIT];
        DatagramPacket datagram = new DatagramPacket(buf, buf.length);
        msocket.receive(datagram);
		return datagram.getData();
    }
 }
