package agentspace.packet;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import agentspace.packet.Packet;
import agentspace.packet.SizeLimitExceededPacketException;

public class Test implements PacketListener {
	AgentMulticastManager manager;

	public Test(int port) {
		try {
			manager = new AgentMulticastManager(port);
			manager.start();
			manager.addPacketListener(this, "AGENTSPACE", "LOOKUP", -1);
			for (int i = 0 ; i < 3 ; i++) {
				Packet p1 = new Packet();
				p1.setProtocol("AGENTSPACE");
				p1.setVersion("0.3");
				p1.setUri(new URI("///identifier"));
				p1.setMethod("LOOKUP");
				manager.multicast(p1);
			}
		} 
		catch (IllegalArgumentException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SizeLimitExceededPacketException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (IOException e) {
			e.printStackTrace();
		} 
		catch (URISyntaxException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void received(Packet packet) {
		System.out.println("Test: received("+packet+")");
		
	}

	public static void main(String[] args) {
		int port;
		try {
			if (args.length > 0) {
				port = new Integer(args[0]).intValue();
			}
			else {
				port = 7010;
			}
			Test t = new Test(port);
		} 
		catch (NumberFormatException ex) {
			System.exit(1);
		}
	}

}
