package agentspace.shell;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Enumeration;
import java.util.Properties;

public abstract class Shell extends Thread {
	Properties environ;
	String[] options;

	public Shell() {
		this.environ  = new Properties();

		for (Enumeration<?> e = environ.propertyNames() ; e.hasMoreElements() ; ) {
			String key = (String)e.nextElement();
			this.environ.put(key, environ.getProperty(key));
		}
	}

	public void run()  {
		String line;
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		try {
			while (true) {
				System.out.print("[AgentSpace]> ");
				System.out.flush();
				line = reader.readLine();
				evaluate(line);
			}
		}
		catch (IOException e) {
			e.printStackTrace();
		}
	}

	public abstract void evaluate(String line);
}