package agentspace.tools;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

public class FileUtil {

	public static void main(String[] args) {
		if (args.length == 0) {
			System.out.println("java FileUtil file(s)");
		}
		else {
			try {
				byte[] data = FileUtil.fileToByteArray(args[0]);
				System.out.println("file = "+args[0]+" : data.lenght = "+data.length);
				FileUtil.byteArrayToFile(args[1], data);
			}
			catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public static byte[] fileToByteArray(File file)	throws IOException {
		byte[] data = null;
		FileInputStream inStream = new FileInputStream(file);
		ByteArrayOutputStream byteout = new ByteArrayOutputStream();
		byte[] bytes = new byte[1024];
		int count;
		while ((count = inStream.read(bytes)) != -1) {
			byteout.write(bytes, 0, count);
		}
		data = byteout.toByteArray();
		byteout.close();
		inStream.close();
		return data;
	}

	public static byte[] fileToByteArray(String fileName) throws IOException {
		File file = new File(fileName);
		return fileToByteArray(file);
	}

	public static void byteArrayToFile(String fileName, byte[] data) throws IOException {
		byteArrayToFile(new File(fileName), data);
	}

	public static void byteArrayToFile(File file, byte[] data) throws IOException {
		FileOutputStream outStream = new FileOutputStream(file);
		outStream.write(data, 0, data.length);
	}

	public static byte[] read(String name) throws IOException {
		return fileToByteArray(name);
	}

	public static void write(String name, byte[] data) throws IOException {
		byteArrayToFile(name, data);
	}
}
